#ifndef BOOTSTRAP_DEVICE_H
#define BOOTSTRAP_DEVICE_H

#include <json/json.h>
#include <future>
#include "utils.h"
#include <flags.h>


class Device {
public:
    Device() {}

    virtual ~Device() {}

    virtual std::string getDeviceName() const = 0;
    virtual std::string getDeviceType() const = 0;

    virtual double getCost(int n_iterations) = 0;
    virtual double getDCost(int n_iterations) = 0;
};

#endif //BOOTSTRAP_DEVICE_H
