#include <flags.h>


Flags::operator bool() const {
    return this->Values != Flags::NONE;
}

Flags operator&(const Flags& lhs, int rhs) {
    auto ret = Flags(lhs.Values & rhs);
    return ret;
}

Flags operator&(int lhs, const Flags& rhs) {
    return rhs & lhs;
}

Flags operator|(const Flags &lhs, int rhs) {
    auto ret = Flags(lhs.Values | rhs);
    return ret;
}

Flags operator|(int lhs, const Flags &rhs) {
    return rhs | lhs;
}

bool operator!(const Flags &flags) {
    if (flags) {
        return false;
    }
    return true;
}

Flags &operator|=(Flags &lhs, int rhs) {
    return lhs = lhs | rhs;
}
