#ifndef BOOTSTRAP_OPTIONS_H
#define BOOTSTRAP_OPTIONS_H

#include <string>
#include <experimental/filesystem>


struct Options {
    std::string forceExecutionPath;
    std::experimental::filesystem::path storageDir;
    std::experimental::filesystem::path iterCountsDir;
    std::experimental::filesystem::path iterCountsFilePath;
    std::experimental::filesystem::path estimatorsDir;
    bool load_iter_counts;
    bool custom_variance;
    float mu;
    float sigma;
    int cuda_device_id;
};


extern struct Options options;

#endif //BOOTSTRAP_OPTIONS_H
